--------------------------------------------------------
-- non_restoring division cell
-- Actually an adder-subtracter
--------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.mypackage.all;

entity complement_cell is
    generic (Length : integer := 8);
    port (
	 		a: in STD_LOGIC_VECTOR (Length-1  downto 0);
			c: in STD_LOGIC;
			ac: out STD_LOGIC_VECTOR (Length-1 downto 0)
     );
end complement_cell;

architecture complement_arch of complement_cell is

signal carry: STD_LOGIC_VECTOR (Length downto 0);
signal a_neg: STD_LOGIC_VECTOR (Length-1 downto 0);

begin

--two_complement: process (c,a)
--begin
--	  if c = '1' then
--			ac <= not(a) + 1;
--	  else
--	 		ac <= a;
--	  end if; 
--end process;

 carry(0) <= c;
 two_complement: for I in 0 to Length-1 generate
		 a_neg(i) <= (a(i) xor c);
		 ac(i) <= (a_neg(i) xor carry(i));
		 carry(i+1) <= (a_neg(i) and carry(i));
  end generate;

end complement_arch;


