----------------------------------------
--	 Conditional Adder
--  Add a+b depeding on x_i
----------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.mypackage.all;

entity cond_adder is
    port (
        a: in STD_LOGIC_VECTOR (MBITS-1 downto 0);
        b: in STD_LOGIC_VECTOR (MBITS-1 downto 0);
        x_i: in STD_LOGIC;
		  r: out STD_LOGIC_VECTOR (MBITS-1 downto 0)
     );
end cond_adder;

architecture cond_adder_arch of cond_adder is

begin

conditional_adder: process (x_i,a,b)
begin
	  if x_i = '1' then
		r <= a + b;
	  else
	 	r <= a;
	  end if; 
end process;


end cond_adder_arch;


