----------------------------------------
--	 Conditional Adder
--  Add a+b depeding on x_i
----------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.mypackage.all;

entity correction_circuit is
    port (
		rem_not_adj : IN std_logic_vector(MBITS downto 0);
		q_not_adj : in std_logic_vector(NBITS-1 downto 0);
		y : IN std_logic_vector(MBITS-1 downto 0);
		sign_X, sign_R : IN std_logic;          
		q : OUT std_logic_vector(NBITS-1 downto 0);
		r : OUT std_logic_vector(MBITS downto 0)
     );
end correction_circuit;

architecture correction_arch of correction_circuit is
signal selection: std_logic_vector(1 downto 0);
begin

selection <= sign_X & sign_R;

corrections: process (selection, q_not_adj, rem_not_adj, y)
begin

   case selection is
      when "00" => q <= q_not_adj; r <= rem_not_adj;
      when "01" => q <= q_not_adj-1; r <= rem_not_adj + y;
      when "10" => q <= q_not_adj+1; r <= rem_not_adj - y;
      when "11" => q <= q_not_adj; r <= rem_not_adj;
      when others => NULL;
   end case;
end process;

end correction_arch;


